Rectangle = Core.class(Sprite)

function Rectangle:init(w, h, color, alpha, x, y)
	self.mesh = Mesh.new()
	self.mesh:setIndexArray(1, 2, 3, 1, 3, 4)
	
	local w, h = w or 0, h or 0
	self.w, self.h = w, h
	self.mesh:setVertices(1,0,0, 2,w,0, 3,w,h, 4,0,h)
	
	local c, a = color or 0x888888, alpha or 1
	self.color, self.alpha = c, a
	self.mesh:setColorArray(c, a, c, a, c, a, c, a)
	
	local x, y = x or 0, y or 0
	self:setPosition(x,y)
	
	self:addChild(self.mesh)
end

function Rectangle:setColor(color, alpha)
	self.color, self.alpha = color or self.color, alpha or self.alpha
	local c, a = self.color, self.alpha
	self.mesh:setColorArray(c, a, c, a, c, a, c, a)	
end

function Rectangle:setSize(w, h)
	self.w, self.h = w or self.w, h or self.h
	local w, h = self.w, self.h
	self.mesh:setVertices(1,0,0, 2,w,0, 3,w,h, 4,0,h)
end

function Rectangle:getSize()
	return self.w, self.h
end

function Rectangle:getColor(color, alpha)
	return self.color, self.alpha
end